package components
{
	import flash.events.Event;
	
	import spark.components.SkinnableContainer;
	import spark.components.ToggleButton;
	import spark.components.supportClasses.TextBase;

	/* Skin States */
	[SkinState("open")]
	[SkinState("closed")]
	
	public class Reveal extends SkinnableContainer
	{
		/* Parts  */
		[SkinPart(required="false")] 
		public var labelDisplay:TextBase;

		[SkinPart] 
		public var openButton:ToggleButton;
		
		
		
		/* Data Model */
		private var _open:Boolean = false;
		private var _label:String;

		/* States */
		override protected function getCurrentSkinState():String
		{
			if(_open)
				return "open";
			else
				return "closed";
		}


		/* get/set functions */
		public function set open(value:Boolean):void
		{
			_open = value;
			invalidateSkinState();	
			invalidateProperties();
		}		
		public function get open():Boolean
		{
			return _open;
		}	
		
		public function set label(value:String):void
		{
			if(_label == value)
				return;
			_label = value;
			if(labelDisplay != null)
				labelDisplay.text = value;
		}
		public function get label():String
		{
			return _label;
		}
		
		
		/* Part Lifecycle */			
		override protected function partAdded(name:String,instance:Object):void
		{
			super.partAdded(name,instance);
			
			if(instance == openButton)	
			{
				openButton.addEventListener(Event.CHANGE,toggleButtonChangeHandler);
				openButton.selected = _open;
			}
			else if (instance == labelDisplay)
			{
				labelDisplay.text = label;
			}
		}

		private function toggleButtonChangeHandler(e:Event):void
		{
			open = openButton.selected;	
		}

	}		
}