package com.fx4ia.robotlegs.contacts
{
	import com.fx4ia.robotlegs.contacts.controller.*;
	import com.fx4ia.robotlegs.contacts.events.ContactEvent;
	import com.fx4ia.robotlegs.contacts.model.ContactsModel;
	import com.fx4ia.robotlegs.contacts.service.*;
	import com.fx4ia.robotlegs.contacts.service.events.ContactServiceEvent;
	import com.fx4ia.robotlegs.contacts.view.*;
	
	import org.robotlegs.mvcs.Context;

	public class ContactManagerContext extends Context
	{
		override public function startup():void
		{
			injector.mapSingleton(ContactsModel);
			injector.mapSingletonOf(IContactService, XMLContactService);
			
			mediatorMap.mapView(ContactsView, ContactsViewMediator);
			mediatorMap.mapView(EditContactView, EditContactViewMediator);
			mediatorMap.mapView(ContactsToolbarView, ContactsToolbarViewMediator);
			
			commandMap.mapEvent(ContactServiceEvent.LOAD, LoadContactsCommand, ContactServiceEvent);
			commandMap.mapEvent(ContactEvent.UPDATE, SaveContactCommand, ContactEvent);
			commandMap.mapEvent(ContactEvent.CREATE, CreateContactCommand);
			commandMap.mapEvent(ContactEvent.CANCEL_CREATE, CreateContactCancelCommand);
			commandMap.mapEvent(ContactEvent.DELETE, DeleteContactCommand);
			commandMap.mapEvent(ContactEvent.EDIT, EditContactCommand);
			commandMap.mapEvent(ContactEvent.CANCEL_EDIT, EditContactCancelCommand);
			commandMap.mapEvent(ContactEvent.SELECT, SelectContactCommand);
		}
	}
}