package com.fx4ia.robotlegs.contacts.service
{
	import com.fx4ia.robotlegs.contacts.model.ContactsModel;
	import com.fx4ia.robotlegs.contacts.model.vo.Contact;
	import com.fx4ia.robotlegs.contacts.service.events.ContactServiceEvent;
	import com.fx4ia.robotlegs.contacts.service.helpers.ContactXMLParser;
	
	import mx.collections.ArrayCollection;
	
	import org.robotlegs.mvcs.Actor;
	
	public class XMLContactService extends Actor implements IContactService
	{
		[Embed(source="/data/contacts.xml",mimeType="text/xml")]
		protected var ContactsXML:Class;
		
		[Inject]
		public var model:ContactsModel;
		
		public function load():void
		{
			var xml:XML = XML( ContactsXML.data );
			model.list = ContactXMLParser.getCollection(xml);
			dispatch(new ContactServiceEvent(ContactServiceEvent.LOADED));
		}
		
		public function save(contact:Contact):void
		{
			if(!model.list.contains(contact))
				model.list.addItem(contact);
			if(contact.id == 0)
				getNextId(contact);
			model.editing = null;
			dispatch(new ContactServiceEvent(ContactServiceEvent.SAVED));
		}
		
		protected function getNextId(forContact:Contact):void
		{
			var id:int = 0;
			for each(var contact:Contact in model.list)
			{
				if(contact.id > id)
					id = contact.id;
			}
			forContact.id = id++;
		}
		
		public function remove(contact:Contact):void
		{
			model.remove(contact);
		}
	}
}