package com.fx4ia.robotlegs.contacts.view
{
	import com.fx4ia.robotlegs.contacts.events.ContactEvent;
	import com.fx4ia.robotlegs.contacts.model.ContactsModel;
	import com.fx4ia.robotlegs.contacts.model.events.ContactsModelEvent;
	
	import org.robotlegs.mvcs.Mediator;
	
	public class ContactsToolbarViewMediator extends Mediator
	{
		[Inject]
		public var view:ContactsToolbarView;
		
		[Inject]
		public var model:ContactsModel;
		
		override public function onRegister():void
		{
			eventMap.mapListener(eventDispatcher, ContactsModelEvent.SELECTED, handleContactSelected);
			eventMap.mapListener(eventDispatcher, ContactsModelEvent.EDITING, handleContactEditing);
			
			eventMap.mapListener(view, ContactEvent.EDIT, dispatch);
			eventMap.mapListener(view, ContactEvent.DELETE, dispatch);
			eventMap.mapListener(view, ContactEvent.CREATE, dispatch);
		}
		
		protected function handleContactSelected(event:ContactsModelEvent):void
		{
			view.selected = model.selected;
		}
		
		protected function handleContactEditing(event:ContactsModelEvent):void
		{
			view.editing = model.editing;
		}
	}
}