package com.fx4ia.robotlegs.contacts.view
{
	import com.fx4ia.robotlegs.contacts.events.ContactEvent;
	import com.fx4ia.robotlegs.contacts.model.ContactsModel;
	import com.fx4ia.robotlegs.contacts.model.events.ContactsModelEvent;
	import com.fx4ia.robotlegs.contacts.model.vo.Contact;
	
	import org.robotlegs.mvcs.Mediator;
	
	public class EditContactViewMediator extends Mediator
	{
		[Inject]
		public var view:EditContactView;
		
		[Inject]
		public var model:ContactsModel;
		
		override public function onRegister():void
		{
			eventMap.mapListener(eventDispatcher, ContactsModelEvent.EDITING, handleContactEditing);
			eventMap.mapListener(view, ContactEvent.CANCEL_EDIT, dispatch);
			eventMap.mapListener(view, ContactEvent.CANCEL_CREATE, dispatch);
			eventMap.mapListener(view, ContactEvent.UPDATE, dispatch);
		}
		
		protected function handleContactEditing(event:ContactsModelEvent):void
		{
			var contact:Contact = model.editing;
			view.clearForm();
			view.contact = contact;
			view.focusOnName();
		}
	}
}