package components{
  import flash.display.Bitmap;
  import flash.display.BitmapData;
  import flash.events.MouseEvent;
  
  import mx.controls.Image;
  import mx.core.DragSource;
  import mx.managers.DragManager;
  
  import spark.components.Label;
  import spark.components.supportClasses.SkinnableComponent;
  import spark.primitives.supportClasses.FilledElement;
  
  public class ProductItem extends SkinnableComponent{
    [SkinPart(required="true")]
    public var imageElement:FilledElement;
    
    [SkinPart(required="true")]
    public var titleElement:Label;
    
    [Bindable]
    public var title:String;
    
    [Bindable]
    public var color:uint;
    
    public function ProductItem(){
      super();
      addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown, false, 0, true);
    }
    
    /*
    //No drag proxy
    protected function onMouseDown(event:MouseEvent):void{
    var ds:DragSource = new DragSource();
    ds.addData(this, "product");
    DragManager.doDrag(this, ds, event);
    }
    */
    
    /*
    //Custom drag proxy
    protected function onMouseDown(event:MouseEvent):void{
      var ds:DragSource = new DragSource();
      ds.addData(this, "product");
      DragManager.doDrag(this, ds, event, new DragProxyGraphic());
    }
    */
    
    //bitmap drag proxy
    protected function onMouseDown(event:MouseEvent):void{
      var screenshot:BitmapData = new BitmapData(width, height);
      screenshot.draw(this);
      var proxy:Image = new Image();
      proxy.source = new Bitmap(screenshot.clone());
      var ds:DragSource = new DragSource();
      ds.addData(this, "product");
      DragManager.doDrag(this, ds, event, proxy);
    }
  }
}