package components{
  import flash.events.Event;
  
  import mx.events.DragEvent;
  import mx.managers.DragManager;
  
  import spark.components.Group;
  import spark.components.Label;
  import spark.components.supportClasses.SkinnableComponent;
  import spark.filters.BlurFilter;
  
  [SkinState("noitems")]
  [SkinState("items")]
  
  public class ShoppingCart extends SkinnableComponent{
    [SkinPart(required="true")]
    public var titleElement:Label;
    
    [SkinPart(required="true")]
    public var contentGroup:Group;
    
    [Bindable]
    public var title:String;
    
    protected var _itemCount:uint = 0;
    [Bindable(event="itemCountChanged")]
    public function get itemCount():uint{ return _itemCount; }
    
    public function ShoppingCart(){
      super();
      addEventListener(DragEvent.DRAG_ENTER, onDragEnter, false, 0, true);
      addEventListener(DragEvent.DRAG_DROP, onDragDrop, false, 0, true);
      addEventListener(DragEvent.DRAG_EXIT, onDragExit, false, 0, true);
    }
    
    protected function onDragEnter(event:DragEvent):void{
      if(event.dragSource.dataForFormat("product") is ProductItem){
        DragManager.acceptDragDrop(this);
        filters = [new BlurFilter()];
      }
    }
    
    protected function onDragExit(event:DragEvent):void{
      filters = [];
    }
    
    protected function onDragDrop(event:DragEvent):void{
      var element:ProductItem = event.dragSource.dataForFormat("product") 
                                                    as ProductItem;
      contentGroup.addElement(element);
      _itemCount = contentGroup.numElements;
      dispatchEvent(new Event("itemCountChanged"));
      invalidateSkinState();
      filters = [];
    }
    
    override protected function getCurrentSkinState():String{
      return _itemCount == 0 ? "noitems" : "items";
    }
  }
}